unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, aPLib, ComCtrls, Buttons, Unit2, ShellAPI;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Image3: TImage;
    OpenDialog1: TOpenDialog;
    aPLib1: TaPLib;
    SpeedButton1: TSpeedButton;
    Panel1: TPanel;
    Timer1: TTimer;
    Image4: TImage;
    Image5: TImage;
    procedure Image3Click(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image5Click(Sender: TObject);
    procedure Image4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  TSectHeader = record
   Name: array[0..7] of Char;
   vSize: DWORD;
   vAddr: DWORD;
   pSize: DWORD;
   pAddr: DWORD;
   oReloc: DWORD;
   oLNums: DWORD;
   sReloc: WORD;
   sLNums: WORD;
   Flags: DWORD;
  end;
  THeaders = array[0..0] of TSectHeader;
  PHeaders = ^THeaders;
  THeadData = record
   Leave: Boolean;
   Compress: Boolean;
  end;
  TResHeader = record
   Flags: DWORD;
   DateTime: DWORD;
   Version: DWORD;
   Names: Word;
   IDs: Word;
  end;
  PResHeader = ^TResHeader;
  TResDescr = record
   DataRVA: DWord;
   DataSize: DWord;
   Codepage: DWord;
   Reserved: DWord;
  end;
  PResDescr = ^TResDescr;
  THeadDataArray = array[0..14] of record RVA, Size: DWORD; end;

var
  Form1: TForm1;
  DefHeadData: array[0..15] of THeadData;
  DefResData: array[0..15] of THeadData;
  ExtraRes: Boolean = true; // selective compression of resources
  State: Byte; // 0 - stopped out; 1 - in; 2 - color +; 3 - color -; 4 - out;

const
  UnpStartSize = 4;
  UnpStart: array[0..3] of Byte = ($EB, $01, $DD, $60);
  UnpOEP = 6;
  UnpEndSize = 12;
  UnpEnd: array[0..11] of Byte = ($90, $EB, $01, $62, $61, $B8, $50, $30, $46, $00, $FF, $E0);
  UnpProcSize = 345;
  UnpProc: array[0..344] of Byte = (
$55, $8B, $EC, $60, $55, $8B, $75, $08, $8B, $7D, $0C, $E8, $02, $00, $00, $00, $EB, $04, $8B, $1C, $24, $C3, $81, $C3, $00, $02, $00, $00, $53, $57, $8B, $07,
$89, $03, $83, $C7, $04, $83, $C3, $04, $4E, $75, $F3, $5F, $5E, $FC, $B2, $80, $8A, $06, $46, $88, $07, $47, $02, $D2, $75, $05, $8A, $16, $46, $12, $D2, $73,
$EF, $02, $D2, $75, $05, $8A, $16, $46, $12, $D2, $73, $4A, $33, $C0, $02, $D2, $75, $05, $8A, $16, $46, $12, $D2, $0F, $83, $D6, $00, $00, $00, $02, $D2, $75,
$05, $8A, $16, $46, $12, $D2, $13, $C0, $02, $D2, $75, $05, $8A, $16, $46, $12, $D2, $13, $C0, $02, $D2, $75, $05, $8A, $16, $46, $12, $D2, $13, $C0, $02, $D2,
$75, $05, $8A, $16, $46, $12, $D2, $13, $C0, $74, $06, $57, $2B, $F8, $8A, $07, $5F, $88, $07, $47, $EB, $A0, $B8, $01, $00, $00, $00, $02, $D2, $75, $05, $8A,
$16, $46, $12, $D2, $13, $C0, $02, $D2, $75, $05, $8A, $16, $46, $12, $D2, $72, $EA, $83, $E8, $02, $75, $28, $B9, $01, $00, $00, $00, $02, $D2, $75, $05, $8A,
$16, $46, $12, $D2, $13, $C9, $02, $D2, $75, $05, $8A, $16, $46, $12, $D2, $72, $EA, $56, $8B, $F7, $2B, $F5, $F3, $A4, $5E, $E9, $58, $FF, $FF, $FF, $48, $C1,
$E0, $08, $8A, $06, $46, $8B, $E8, $B9, $01, $00, $00, $00, $02, $D2, $75, $05, $8A, $16, $46, $12, $D2, $13, $C9, $02, $D2, $75, $05, $8A, $16, $46, $12, $D2,
$72, $EA, $3D, $00, $7D, $00, $00, $73, $1A, $3D, $00, $05, $00, $00, $72, $0E, $41, $56, $8B, $F7, $2B, $F0, $F3, $A4, $5E, $E9, $18, $FF, $FF, $FF, $83, $F8,
$7F, $77, $03, $83, $C1, $02, $56, $8B, $F7, $2B, $F0, $F3, $A4, $5E, $E9, $03, $FF, $FF, $FF, $8A, $06, $46, $33, $C9, $C0, $E8, $01, $74, $12, $83, $D1, $02,
$8B, $E8, $56, $8B, $F7, $2B, $F0, $F3, $A4, $5E, $E9, $E7, $FE, $FF, $FF, $5D, $2B, $7D, $0C, $89, $7D, $FC, $61, $5D, $C3);
  ResTypes: array[0..15] of DWORD = (9,21,22,2,1,5,8,7,12,14,3,4,11,10,6,16);

function PackCB(w1,w2: DWORD): DWORD; cdecl;
implementation

{$R *.DFM}

function PackCB(w1,w2: DWORD): DWORD;
begin
// Form1.Timer1Timer(nil);
 Application.ProcessMessages;
end;

procedure TForm1.Image3Click(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.Label1Click(Sender: TObject);
var
 f: file;
 o: file;
 fNm: string;
 k: Integer;
 Wrd, SectCnt, nSectCnt, nCompCnt, SectAddr, SectInd: WORD;
 PeSize, PeHead, Sect: WORD;
 dWrd, OEP, nSectPos, ImgBase: DWORD;
 TlsPos: DWORD;
 HeadData: THeadDataArray;
 HeadDataSize: DWORD;
 CodeSize, InitSize, UInitSize: DWORD;
 SectAlign,FileAlign: DWORD;
 Head,Src,Trg: PByteArray;
 SectHead: TSectHeader;
 Addr: DWORD;
 NewSect: PByteArray;
 NewSectSize: DWORD;
 MaxRVA, MaxSize: DWORD;
 Headers: PHeaders;
 ResHeader: TResHeader;
 ResCnt: Word;
 MinResRVA,NonCmpResSz,CmpResSz,CurCmpPs,CurNonCmpPs,CmpStart,NonCmpStart: DWord;
 Data: array of THeadData;
 function ResCompress(ID: DWord): Boolean;
 var
  k: Byte;
 begin
  Result := false;
  for k := 0 to 15 do
   if ID = ResTypes[k] then
   begin
    Result := DefResData[k].Compress;
    Exit;
   end;
 end;
 function IsSubTable(A: DWord): Boolean;
 begin
  Result := A or $80000000 = A;
 end;
 procedure CompressSubHeaders(A: DWord; Cmp: Boolean; VOffs, POffs: DWord);
 var
  Hdr: PResHeader;
  Descr: PResDescr;
  k: Word;
 begin
  Hdr := PResHeader(@Trg[A]);
  for k := 0 to Hdr^.IDs + Hdr^.Names - 1 do
   if IsSubTable(PDWORD(@Trg[A + $14 + k*8])^) then
    CompressSubHeaders(PDWORD(@Trg[A + $14 + k*8])^ and $7FFFFFFF,Cmp,VOffs,POffs)
   else
   begin
    Descr := PResDescr(@Trg[PDWORD(@Src[A + $14 + k*8])^]);
    Seek(f,Descr^.DataRVA - VOffs + POffs);
    if Cmp then
    begin
     Descr^.DataRVA := CurCmpPs;
     BlockRead(f,Trg[CurCmpPs - VOffs],Descr^.DataSize);
     Inc(CurCmpPs,Descr^.DataSize);
    end else
    begin
     Descr^.DataRVA := CurNonCmpPs;
     BlockRead(f,Trg[CurNonCmpPs - VOffs],Descr^.DataSize);
     Inc(CurNonCmpPs,Descr^.DataSize);
    end;
   end;
 end;
 procedure ProcessSubHeaders(A: DWord; Cmp: Boolean);
 var
  Hdr: PResHeader;
  Descr: PResDescr;
  k: Word;
 begin
  Hdr := PResHeader(@Trg[A]);
  for k := 0 to Hdr^.IDs + Hdr^.Names - 1 do
   if IsSubTable(PDWORD(@Trg[A + $14 + k*8])^)  then
    ProcessSubHeaders(PDWORD(@Trg[A + $14 + k*8])^ and $7FFFFFFF,Cmp)
   else
   begin
    Descr := PResDescr(@Trg[PDWORD(@Trg[A + $14 + k*8])^]);
    if Descr^.DataRVA < MinResRVA then
     MinResRVA := Descr^.DataRVA;
    if Cmp then
     Inc(CmpResSz,Descr^.DataSize)
    else
     Inc(NonCmpResSz,Descr^.DataSize);
   end;
 end;
 function AlignTo(V, A: DWORD): DWORD;
 begin
  if V mod A = 0 then
   Result := V
  else
   Result := V - V mod A + A;
 end;
 function WithinRange(Range,Size,Value: DWORD): Boolean;
 begin
  Result := (Range <= Value) and (Value < Range + Size);
 end;
begin
 if OpenDialog1.Execute then
 begin
  // preparing
  Randomize;
  fNm := OpenDialog1.FileName;
  apLib1.CallBack := PackCB;
  State := 1;
  Enabled := false;
  //opening source...
  AssignFile(f,fNm);
  Reset(f,1);
  //...and temporary files
  AssignFile(o,ChangeFileExt(fNm,'.out'));
  Rewrite(o,1);
  //reading data from PE header
  Seek(f,$0000003C);
  BlockRead(f,PeHead,2);
  Seek(f,PeHead + $0000006);
  BlockRead(f,SectCnt,2);
  Seek(f,PeHead + $0000014);
  BlockRead(f,PeSize,2);
  PeSize := PeHead + PeSize + $00000018;
  Seek(f,PeHead + $0000038);
  BlockRead(f,SectAlign,4);
  Seek(f,PeHead + $000003C);
  BlockRead(f,FileAlign,4);
  FileAlign := $200;
  Seek(f,PeHead + $0000028);
  BlockRead(f,OEP,4);
  Seek(f,PeHead + $0000034);
  BlockRead(f,ImgBase,4);
  Seek(f,PeHead + $0000074);
  BlockRead(f,HeadDataSize,4);
  if HeadDataSize > 15 then HeadDataSize := 15;
  //reading directories...
  ZeroMemory(@HeadData,88);
  BlockRead(f,HeadData,HeadDataSize*8);
  //moving headers (w/o section headers) from source to destination
  GetMem(Head,PeSize);
  Seek(f,0);
  BlockRead(f,Head^,PeSize);
  BlockWrite(o,Head^,PeSize);
  FreeMem(Head);
  //reading section headers
  GetMem(Headers,SectCnt*$00000028);
  BlockRead(f,Headers^,SectCnt*$00000028);
  SetLength(Data,SectCnt);
  nSectCnt := 1;
  nCompCnt := 0;
  //preprocessing section headers
  for Sect := 0 to SectCnt - 1 do
  begin
   Data[Sect] := DefHeadData[15];
   for k := 0 to 14 do
    if WithinRange(Headers^[Sect].vAddr,
                   Headers^[Sect].vSize,
                   HeadData[k].RVA) then
    begin
     Data[Sect] := DefHeadData[k];
     if not Data[Sect].Leave then
     begin
      HeadData[k].RVA := 0;
      HeadData[k].Size := 0;
     end;
     Break;
    end;
   {if Data[Sect].Leave then }Inc(nSectCnt);
   if Data[Sect].Compress then
    Data[Sect].Compress := Headers^[Sect].pSize > 255;
   if Data[Sect].Compress then Inc(nCompCnt);
  end;
  // compressing sections
  Addr := AlignTo(PeSize + nSectCnt*$00000028,FileAlign);
  Seek(o,PeHead + $00000054);
  BlockWrite(o,Addr,4);
  NewSectSize := nCompCnt*15 + 361{ + $0A};
  GetMem(NewSect,NewSectSize);
  nSectPos := UnpStartSize;
  Move(UnpStart[0],NewSect[0],4);
  CodeSize := 0;
  InitSize := 0;
  UInitSize := 0;
  MaxRVA := 0;
  MaxSize := 0;
  SectAddr := PeSize;
  SectInd := 0;
  TlsPos := 0;
  for Sect := 0 to SectCnt - 1 do
  // if Data[Sect].Leave then
   begin
    if not Data[Sect].Leave then
     Headers^[Sect].pSize := 0;
    GetMem(Src,Headers^[Sect].pSize);
    Seek(f,Headers^[Sect].pAddr);
    BlockRead(f,Src^,Headers^[Sect].pSize);
    if WithinRange(Headers^[Sect].vAddr,Headers^[Sect].vSize,HeadData[9].RVA) then
     TlsPos := Addr + HeadData[9].RVA - Headers^[Sect].vAddr;
    if not Data[Sect].Compress then
     //simply copy section to new file
     Trg := Src
    else
     if ExtraRes and (Headers^[Sect].vAddr = HeadData[2].RVA) then // resources!
     begin
      // copy all section to destination
      GetMem(Trg,Headers^[Sect].pSize);
      Move(Src^,Trg^,Headers^[Sect].pSize);
      ResHeader := PResHeader(Src)^;
      // search minimal RVA of resource entry; pass 1
      MinResRVA := $FFFFFFFF;
      NonCmpResSz := 0;
      CmpResSz := 0;
      for ResCnt := 0 to ResHeader.IDs + ResHeader.Names - 1 do
       ProcessSubHeaders(PDWORD(@Src[$14 + ResCnt*8])^ and $7FFFFFFF,
        ResCompress(PDWORD(@Src[$10 + ResCnt*8])^ and $7FFFFFFF));
      CurNonCmpPs := MinResRVA;
      CurCmpPs := MinResRVA + NonCmpResSz;
      CmpStart := MinResRVA + NonCmpResSz - Headers^[Sect].vAddr;
      NonCmpStart := MinResRVA - Headers^[Sect].vAddr;
      // rebuild & compress resource entries; pass 2
      for ResCnt := 0 to ResHeader.IDs + ResHeader.Names - 1 do
       CompressSubHeaders(PDWORD(@Src[$14 + ResCnt*8])^ and $7FFFFFFF,
        ResCompress(PDWORD(@Src[$10 + ResCnt*8])^ and $7FFFFFFF),
         Headers^[Sect].vAddr,Headers^[Sect].pAddr);
      apLib1.Source := @Trg[CmpStart];
      apLib1.Length := CmpResSz;
      apLib1.Pack;
      if apLib1.Length > 0 then
      begin
       Move(apLib1.Destination^,Trg[CmpStart],apLib1.Length);
       //add decompressing code
       NewSect[nSectPos] := $68;
       PDWORD(@NewSect[nSectPos + 1])^ := MinResRVA + ImgBase + NonCmpResSz;
       NewSect[nSectPos + 5] := $68;
       PDWORD(@NewSect[nSectPos + 6])^ := apLib1.Length div 4 + 1;
       NewSect[nSectPos + 10] := $E8;
       PDWORD(@NewSect[nSectPos + 11])^ := nCompCnt*15 - nSectPos + 1;
      end else
      begin
       apLib1.Length := CmpResSz;
       NewSect[nSectPos] := $E8;
       PDWORD(@NewSect[nSectPos + 1])^ := 1;
       NewSect[nSectPos + 5] := Random(256);
       PDWORD(@NewSect[nSectPos + 6])^ := $0A240483;
       NewSect[nSectPos + 10] := $C3;
       NewSect[nSectPos + 11] := Random(256);
       NewSect[nSectPos + 12] := Random(256);
       NewSect[nSectPos + 13] := Random(256);
       NewSect[nSectPos + 14] := Random(256);
      end;
      //change physical and virtual sizes
      Headers^[Sect].pSize := AlignTo(CmpStart + apLib1.Length,FileAlign);
      Inc(nSectPos,15);
     end else
     begin
      //pack section
      apLib1.Source := Src;
      apLib1.Length := Headers^[Sect].pSize;
      apLib1.Pack;
      if apLib1.Length > 0 then
      begin
       Trg := apLib1.Destination;
       //change physical and virtual sizes
       Headers^[Sect].pSize := AlignTo(apLib1.Length,FileAlign);
       //add decompressing code
       NewSect[nSectPos] := $68;
       PDWORD(@NewSect[nSectPos + 1])^ := Headers^[Sect].vAddr + ImgBase;
       NewSect[nSectPos + 5] := $68;
       PDWORD(@NewSect[nSectPos + 6])^ := Headers^[Sect].pSize div 4 + 1;
       NewSect[nSectPos + 10] := $E8;
       PDWORD(@NewSect[nSectPos + 11])^ := nCompCnt*15 - nSectPos + 1;
      end else
      begin
       Trg := Src;
       NewSect[nSectPos] := $E8;
       PDWORD(@NewSect[nSectPos + 1])^ := 1;
       NewSect[nSectPos + 5] := Random(256);
       PDWORD(@NewSect[nSectPos + 6])^ := $0A240483;
       NewSect[nSectPos + 10] := $C3;
       NewSect[nSectPos + 11] := Random(256);
       NewSect[nSectPos + 12] := Random(256);
       NewSect[nSectPos + 13] := Random(256);
       NewSect[nSectPos + 14] := Random(256);
      end;
      Inc(nSectPos,15);
     end;
    //updating fields
    //Headers^[Sect].vSize := AlignTo(Headers^[Sect].vSize,SectAlign);
    Headers^[Sect].Flags := Headers^[Sect].Flags or $C0000040;
    Headers^[Sect].pAddr := Addr;
    //writing new section header
    Seek(o,SectAddr);
    BlockWrite(o,Headers^[Sect],$00000028);
    //writing section data
    Seek(o,Headers^[Sect].pAddr);
    BlockWrite(o,Trg^,Headers^[Sect].pSize);
    Addr := AlignTo(Addr + Headers^[Sect].pSize,FileAlign);
    if Headers^[Sect].Flags or $00000020 = Headers^[Sect].Flags then
     Inc(CodeSize,Headers^[Sect].pSize);
    if Headers^[Sect].Flags or $00000040 = Headers^[Sect].Flags then
     Inc(InitSize,Headers^[Sect].pSize);
    if Headers^[Sect].Flags or $00000080 = Headers^[Sect].Flags then
     Inc(UInitSize,Headers^[Sect].pSize);
    if Headers^[Sect].vAddr + Headers^[Sect].vSize > MaxRVA then
     MaxRVA := Headers^[Sect].vAddr + Headers^[Sect].vSize;
    if Headers^[Sect].vSize > MaxSize then
     MaxSize := Headers^[Sect].vSize;
    Inc(SectAddr,$00000028);
    Inc(SectInd);
   end;
  for k := 0 to 14 do
   if not DefHeadData[k].Leave then
   begin
    HeadData[k].RVA := 0;
    HeadData[k].Size := 0;
   end;
  // adding new section
  Move(UnpEnd[0],NewSect[nSectPos],UnpEndSize);
  PDWORD(@NewSect[nSectPos + UnpOEP])^ := OEP + ImgBase;
  Inc(nSectPos,UnpEndSize);
  Move(UnpProc[0],NewSect[nSectPos],UnpProcSize);
  MaxRVA := AlignTo(MaxRVA,SectAlign);
  with SectHead do
  begin
   Name := '.depack'#0;
   vSize := AlignTo(NewSectSize + MaxSize,SectAlign);
   vAddr := MaxRVA;
   MaxRVA := vAddr + vSize;
   pSize := NewSectSize;
   pAddr := Addr;
   oReloc := 0;
   oLNums := 0;
   sReloc := 0;
   sLNums := 0;
   Flags := $E00000E0;
  end;
  // changing entrypoint
  Seek(o,PeHead + $00000028);
  BlockWrite(o,SectHead.vAddr,4);
  // writing header of unpack section...
  Seek(o,PeSize + (nSectCnt - 1)*$00000028);
  BlockWrite(o,SectHead,$00000028);
  // ..and unpack section data
  Seek(o,Addr);
  BlockWrite(o,NewSect^,NewSectSize);
  // updating PE header fields
  Seek(o,PeHead + $00000050);
  BlockWrite(o,MaxRVA,4);
  Seek(o,PeHead + $0000001C);
  BlockWrite(o,CodeSize,4);
  BlockWrite(o,InitSize,4);
  BlockWrite(o,UInitSize,4);
  Seek(o,PeHead + $000003C);
  BlockWrite(o,FileAlign,4);
  Wrd := nSectCnt;
  Seek(o,PeHead + $00000006);
  BlockWrite(o,Wrd,2);
  // updating directories
  Seek(o,PeHead + $00000078);
  BlockWrite(o,HeadData,HeadDataSize*8);
  // updating TLS
  if DefHeadData[9].Leave and not DefHeadData[9].Compress and (TlsPos > 0) then
  begin
   DWrd := ImgBase + SectHead.vAddr + $1000;
   Seek(o,TlsPos + 8);
   BlockWrite(o,DWrd,4);
  end;
  CloseFile(f);
  CloseFile(o);
  // replacing old file
  RenameFile(fNm,ChangeFileExt(fNm,'.bak'));
  DeleteFile(fNm);
  RenameFile(ChangeFileExt(fNm,'.out'),fNm);
  DeleteFile(ChangeFileExt(fNm,'.out'));
  State := 4;
  Enabled := true;
 end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
 k: Integer;
begin
 with form2.CheckListBox1 do
  for k := 0 to 15 do
   if DefHeadData[k].Leave then
    if DefHeadData[k].Compress then
     State[k] := cbChecked
    else
     State[k] := cbGrayed
   else
    State[k] := cbUnchecked;
 with form2.CheckListBox2 do
  for k := 0 to 15 do
  // if DefResData[k].Leave then
    if DefResData[k].Compress then
     State[k] := cbChecked
 //   else
 //    State[k] := cbGrayed
   else
    State[k] := cbUnchecked;
 form2.CheckBox4.Checked := ExtraRes;
 if form2.ShowModal = mrOK then
 begin
  with form2.CheckListBox1 do
   for k := 0 to 15 do
   begin
    DefHeadData[k].Leave := State[k] <> cbUnchecked;
    DefHeadData[k].Compress := State[k] = cbChecked;
   end;
  with form2.CheckListBox2 do
   for k := 0 to 15 do
   begin
    DefResData[k].Leave := State[k] <> cbUnchecked;
    DefResData[k].Compress := State[k] = cbChecked;
   end;
  ExtraRes := form2.CheckBox4.Checked;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
 k: Integer;
begin
 for k := 0 to 15 do
  case k of
   0..1,9: begin
    DefHeadData[k].Leave := true;
    DefHeadData[k].Compress := false;
   end;
  { 5: begin
    DefHeadData[k].Leave := false;
    DefHeadData[k].Compress := false;
   end; }
   2,15: begin
    DefHeadData[k].Leave := true;
    DefHeadData[k].Compress := true;
   end;
   else begin
    DefHeadData[k].Leave := false;
    DefHeadData[k].Compress := false;
   end;
  end;
 for k := 0 to 15 do
  case k of
   0..8,11..14: begin
    DefResData[k].Leave := true;
    DefResData[k].Compress := true;
   end;
   else begin
    DefResData[k].Leave := true;
    DefResData[k].Compress := false;
   end;
  end;
 State := 3;
 if ParamCount > 0 then
 begin
  OpenDialog1.FileName := ParamStr(1);
  Label1Click(nil);
 end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
 C: TColor;
 R,G,B: Byte;
begin
 C := Panel1.Color;
 if State = 2 then
 begin
  R := GetRValue(C); G := GetBValue(C); B := GetBValue(C);
  if R < 255 then Inc(R,15) else State := 3;
  C := RGB(R,G,B);
 end else
 if State = 3 then
 begin
  R := GetRValue(C); G := GetBValue(C); B := GetBValue(C);
  if R > 128 then Dec(R,15) else State := 2;
  C := RGB(R,G,B);
 end else
  C := clRed;
 if State = 1 then
 begin
  if Panel1.Left + 70 < 25 then Panel1.Left := Panel1.Left + 70 else
  begin
   Panel1.Left := 25;
   State := 3;
  end;
 end else
 if State = 4 then
 begin
  if Panel1.Left < 350 then Panel1.Left := Panel1.Left + 70 else
  begin
   State := 0;
   Panel1.Left := -300;
  end;
 end;
 Panel1.Color := C;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 Image5.Visible := (X > 110) and (X < 207) and (Y > 45) and (Y < 58);
 Image4.Visible := (X > 103) and (X < 199) and (Y > 58) and (Y < 70);
end;

procedure TForm1.Image5Click(Sender: TObject);
begin
 ShellExecute(0,'open','mailto:denull@narod.ru?subject=Packer',nil,nil,SW_SHOWNORMAL);
end;

procedure TForm1.Image4Click(Sender: TObject);
begin
 ShellExecute(0,'open','http://clteam.net/',nil,nil,SW_SHOWNORMAL);
end;

end.
